package edu.ntnu.cikmr.arbitration;

import com.hp.hpl.jena.ontology.*;
import edu.ntnu.cikmr.arbitration.workflow.*;
import edu.ntnu.cikmr.ontologies.*;
import edu.ntnu.cikmr.arbitration.cbr.*;

public class CaseContainer extends Case{
    protected Activity local;
    protected Activity remote;

    public CaseContainer(Activity local, Activity remote){
        this.local = local;
        this.remote = remote;

        this.setCase1(local.getType());
        this.setCase2(remote.getType());
        this.setLocation(locationNearness(local.getLocation(), remote.getLocation()));
    }

    private double locationNearness(String location1, String location2){
        if(location1.equals(location2)){
            return 1.0;
        }

        OntClass ontClass = OntologyUtils.findOwner("Location", location1);

        switch(OntologyUtils.getDownwardDistance(ontClass, location2)){
        case -1:
            switch(OntologyUtils.getUpwardDistance(ontClass, location2)){
            case 0:
                return 0.75;
            case 1:
                return 0.25;
            }
            return 0.00;
        case 0:
            return 0.75;
        case 1:
            return 0.50;
        case 2:
            return 0.25;
        }
        return 0.00;
    }

    public boolean equals(Object o){
        if(o instanceof CaseContainer){
            CaseContainer c = (CaseContainer)o;
            return(local.equals(c.local) && remote.equals(c.remote));
        }else return false;
    }

    public int hashCode(){
        int hashCode = local == null ? 0 : local.hashCode();
        hashCode += remote == null ? 0 : remote.hashCode();
        return hashCode;
    }

    public Activity getLocal() {
        return local;
    }

    public Activity getRemote() {
        return remote;
    }

}
