package edu.ntnu.cikmr.arbitration.cbr;

import java.util.*;

import com.hp.hpl.jena.ontology.*;
import edu.ntnu.cikmr.ontologies.*;
import jcolibri.cbrcase.Individual;
import jcolibri.extensions.DL.datatypes.*;
import jcolibri.similarity.*;

public class CaseSimilarity implements SimilarityFunction {
    private HashMap parametersInfo;

    /**
     * compute
     *
     * @param individual Individual
     * @param individual1 Individual
     * @return double
     * @todo Implement this jcolibri.similarity.SimilarityFunction method
     */
    public double compute(Individual individual1, Individual individual2) {
        if(!(individual1.getValue() instanceof ConceptType) ||
           !(individual2.getValue() instanceof ConceptType)) return 0.0;

        String localName1 = ((ConceptType)individual1.getValue()).getOntIndividual().getLocalName();
        String localName2 = ((ConceptType)individual2.getValue()).getOntIndividual().getLocalName();

        if(localName1.equals(localName2)){
            return 1.0;
        }

        OntClass ontClass = OntologyUtils.findOwner("Case_1", localName1);

        switch(OntologyUtils.getDownwardDistance(ontClass, localName2)){
            case -1:
                switch(OntologyUtils.getUpwardDistance(ontClass, localName2)){
                    case 0:
                        return 0.75;
                    case 1:
                        return 0.25;
                }
                return 0.00;
            case 0:
                return 0.75;
            case 1:
                return 0.50;
            case 2:
                return 0.25;
        }
        return 0.00;
    }

    /**
     * getParametersInfo
     *
     * @return HashMap
     * @todo Implement this jcolibri.similarity.SimilarityFunction method
     */
    public HashMap getParametersInfo() {
        return parametersInfo;
    }

    /**
     * setParameters
     *
     * @param hashMap HashMap
     * @todo Implement this jcolibri.similarity.SimilarityFunction method
     */
    public void setParameters(HashMap hashMap) {
        parametersInfo = hashMap;
    }
}
