package edu.ntnu.cikmr.arbitration.cbr;

import java.util.*;

import jcolibri.cbrcase.*;
import jcolibri.cbrcore.*;
import jcolibri.cbrcore.exception.*;
import jcolibri.extensions.DL.datatypes.ConceptType;
import jcolibri.util.CaseCreatorUtils;

public class SelectBestCasesMethod extends CBRMethod{
    private static final long serialVersionUID = 1L;
    private double threshold = 0.80;

    public CBRContext execute(CBRContext context) throws ExecutionException {
        List<CBRCase> cases = new ArrayList<CBRCase>();
        context.setCases(cases);

        if(context.getEvaluatedCases() == null || context.getEvaluatedCases().size() == 0) throw new ExecutionException("Could not find any evaluated cases.");
        Iterator i = context.getEvaluatedCases().iterator();

        while(i.hasNext()){
            CaseEvaluation eval = (CaseEvaluation)i.next();

//            printCase(eval.getCase());

            double evalVal = 0;
            if(eval.getEvaluation() instanceof Double) evalVal = ((Double)eval.getEvaluation()).doubleValue();
            if(evalVal >= threshold) cases.add(eval.getCase());
        }

//        if(cases.size() == 0){
//            CBRCase newCase = CaseCreatorUtils.createCase("arbitration/caseStructure.xml");
//            CaseCreatorUtils.setCaseName(newCase, "newCase");
//            cases.add(newCase);
//        }

        return context;
    }

    private void printCase(CBRCase c){
        try {
            IndividualRelation i = null;
            ConceptType ct = null;

            i = c.getDescription().getRelation("has-Description.Case_1");

            if(i != null) System.out.println(i.getDescription() + " : " + i.getTarget().getValue());

            if(i.getTarget().getValue() instanceof ConceptType) ct = (ConceptType)i.getTarget().getValue();
            if(ct != null){
                System.out.println(ct.getConcept());
                System.out.println(ct.getOntIndividual());
            }



        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

}
