package edu.ntnu.cikmr.arbitration.messages;

import edu.ntnu.cikmr.arbitration.cbr.Case;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class ConflictMessage extends Case{

    public ConflictMessage(){}

    public String toXML(){
        return "<conflict case1=\"" + getCase1() + "\" case2=\"" + getCase2() + "\" location=\"" + getLocation() + "\" participants=\"" + getParticipants() + "\" solution=\"" + getSolution() + "\" property=\"" + getProperty() + "\"/>";
    }

    public static ConflictMessage fromCase(Case c){
        ConflictMessage m = new ConflictMessage();
        m.setCase1(c.getCase1());
        m.setCase2(c.getCase2());
        m.setId(c.getId());
        m.setSolution(c.getSolution());
        m.setProperty(c.getProperty());
        m.setLocation(c.getLocation());
        m.setParticipants(c.getParticipants());
        return m;
    }

    public static ConflictMessage fromXML(Node n){
        ConflictMessage c = new ConflictMessage();

        NamedNodeMap nodeMap = n.getAttributes();
        Node case1 = nodeMap.getNamedItem("case1");
        c.setCase1(case1 == null ? null : case1.getNodeValue());

        Node case2 = nodeMap.getNamedItem("case2");
        c.setCase2(case2 == null ? null : case2.getNodeValue());

        Node location = nodeMap.getNamedItem("location");
        try{
            c.setLocation(location == null ? null : Double.parseDouble(location.getNodeValue()));
        } catch(Exception ex){}

        Node participants = nodeMap.getNamedItem("participants");
        try{
            c.setLocation(participants == null ? null : Double.parseDouble(participants.getNodeValue()));
        } catch(Exception ex){}

        Node solution = nodeMap.getNamedItem("solution");
        c.setSolution(solution == null ? null : solution.getNodeValue());

        Node property = nodeMap.getNamedItem("property");
        c.setProperty(property == null ? null : property.getNodeValue());

        return c;
    }

    public static void main(String args[]){
        Case c = new Case();
        ConflictMessage m = (ConflictMessage)c;

    }

}
