package edu.ntnu.cikmr.arbitration.messages;

import java.util.*;
import java.util.Map.Entry;

import org.w3c.dom.*;

public class SolutionMessage{
    private String type;
    private Hashtable<String,String> parameters;

    public SolutionMessage(){
        parameters = new Hashtable<String,String>();
    }

    public String toXML(){
        String xml = "<solution type=\"" + type + "\"";
        if(parameters.isEmpty()){
            xml += "/>";
        }else{
            xml += ">\n";
            Iterator<Entry<String,String>> iterator = parameters.entrySet().iterator();
            while(iterator.hasNext()){
                Entry<String,String> entry = iterator.next();
                xml += "<parameter name=\"" + entry.getKey() + "\" value=\"" + entry.getValue() + "\"/>";
            }
            xml += "</solution>";
        }
        return xml;
    }

    public static SolutionMessage fromXML(Node n){
        SolutionMessage s = new SolutionMessage();

        NamedNodeMap nodeMap = n.getAttributes();
        Node type = nodeMap.getNamedItem("type");
        s.setType(type == null ? null : type.getNodeValue());

        NodeList nodeList = n.getChildNodes();
        for(int i = 0; i < nodeList.getLength(); i++){
            Node childNode = nodeList.item(i);
            if(childNode.getNodeName().equalsIgnoreCase("parameter")){
                NamedNodeMap parameterNodeMap = childNode.getAttributes();
                Node name = parameterNodeMap.getNamedItem("name");
                Node value = parameterNodeMap.getNamedItem("value");
                if(name != null && value != null) s.putParameter(name.getNodeValue(), value.getNodeValue());
            }
        }
        return s;
    }

    public String getParameter(String key){
        return parameters.get(key);
    }

    public String putParameter(String key, String value){
        return parameters.put(key, value);
    }

    public boolean hasParameter(String key){
        return parameters.containsKey(key);
    }

    public Iterator<Entry<String,String>> getParameterIterator(){
        return parameters.entrySet().iterator();
    }

    public String getType(){
        return type;
    }

    public void setType(String type){
        this.type = type;
    }

}
