package edu.ntnu.cikmr.arbitration.workflow;

import edu.ntnu.cikmr.XMLRepresentation;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class Activity implements XMLRepresentation{
    private String type;
    private String id;
    private String pipeID;
    private String workflowID;
    private String location;

    public Activity(){}

    public Activity(String id, String type, String location, String pipeID, String workflowID){
        this.id = id;
        this.type = type;
        this.location = location;
        this.pipeID = pipeID;
        this.workflowID = workflowID;
    }

    public String getId(){
        return id;
    }

    public String getLocation(){
        return location;
    }

    public String getType(){
        return type;
    }

    public String getPipeID(){
        return pipeID;
    }

    public String getWorkflowID(){
        return workflowID;
    }

    public void setId(String id){
        this.id = id;
    }

    public void setLocation(String location){
        this.location = location;
    }

    public void setType(String type){
        this.type = type;
    }

    public void setPipeID(String pipeID){
        this.pipeID = pipeID;
    }

    public void setWorkflowID(String workflowID){
        this.workflowID = workflowID;
    }

    public void fromXML(Node n){
        NamedNodeMap nodeMap = n.getAttributes();
        Node id = nodeMap.getNamedItem("id");
        this.id = id == null ? null : id.getNodeValue();
        Node type = nodeMap.getNamedItem("type");
        this.type = type == null ? null : type.getNodeValue();
        Node location = nodeMap.getNamedItem("location");
        this.location = location == null ? null : location.getNodeValue();
        Node pipeID = nodeMap.getNamedItem("pipeID");
        this.pipeID = pipeID == null ? null : pipeID.getNodeValue();
        Node workflowID = nodeMap.getNamedItem("workflowID");
        this.workflowID = workflowID == null ? null : workflowID.getNodeValue();
    }

    public String toXML(){
        return "<activity id=\"" + id +"\" type=\"" + type +"\" location=\"" + location + "\" pipeID=\"" + pipeID + "\" workflowID=\"" + workflowID + "\"/>";
    }

    public boolean equals(Object o){
        if(o instanceof Activity){
            Activity a = (Activity)o;
            boolean i = stringMatch(getId(), a.getId());
            boolean t = stringMatch(getType(), a.getType());
            boolean l = stringMatch(getLocation(), a.getLocation());
            return i && t && l;
        } else return false;
    }

    public boolean stringMatch(String s1, String s2){
        if(s1 == null && s2 == null) return true;
        if(s1 == null || s2 == null) return false;
        return s1.equals(s2);
    }

    public int hashCode(){
        int hashCode = id == null ? 0 : id.hashCode();
        hashCode += type == null ? 0 : type.hashCode();
        hashCode += location == null ? 0 : location.hashCode();
        return hashCode;
    }

}
