package edu.ntnu.cikmr.arbitration.workflow;

import java.util.ArrayList;
import java.util.Iterator;

import org.w3c.dom.*;

public class Goal extends Activity{
    private ArrayList<Activity> activities;

    public Goal(){
        init();
    }

    public Goal(String id, String type, String location, String pipeID, String workflowID){
        super(id, type, location, pipeID, workflowID);
        init();
    }

    private void init(){
        activities = new ArrayList<Activity>();
    }

    public void add(Activity activity){
        activities.add(activity);
    }

    public Iterator<Activity> activityIterator(){
        return activities.iterator();
    }

    public void fromXML(Node n){
        NamedNodeMap nodeMap = n.getAttributes();
        Node id = nodeMap.getNamedItem("id");
        setId(id == null ? null : id.getNodeValue());
        Node type = nodeMap.getNamedItem("type");
        setType(type == null ? null : type.getNodeValue());
        Node location = nodeMap.getNamedItem("location");
        setLocation(location == null ? null : location.getNodeValue());
        Node pipeID = nodeMap.getNamedItem("pipeID");
        setPipeID(pipeID == null ? null : pipeID.getNodeValue());
        Node workflowID = nodeMap.getNamedItem("workflowID");
        setWorkflowID(workflowID == null ? null : workflowID.getNodeValue());

        NodeList nodeList = n.getChildNodes();
        for(int i = 0; i < nodeList.getLength(); i++){
            Node childNode = nodeList.item(i);
            if(childNode.getNodeName().equalsIgnoreCase("goal")){
                Goal goal = new Goal();
                goal.fromXML(childNode);
                add(goal);
            }else if(childNode.getNodeName().equalsIgnoreCase("activity")){
                Activity activity = new Activity();
                activity.fromXML(childNode);
                add(activity);
            }
        }
    }

    public String toXML(){
        String xml = "<goal id=\"" + getId() +"\" type=\"" + getType() +"\" location=\"" + getLocation() + "\" pipeID=\"" + getPipeID() + "\" workflowID=\"" + getWorkflowID() + "\"";
        if(activities.isEmpty()){
            xml += "/>";
        }else{
            xml += ">\n";
            Iterator<Activity> iterator = activities.iterator();
            while(iterator.hasNext()){
                xml += iterator.next().toXML() + "\n";
            }
            xml += "</goal>";
        }
        return xml;
    }

}
