package edu.ntnu.cikmr.gui;

import javax.swing.*;
import edu.ntnu.cikmr.network.*;
import edu.ntnu.cikmr.Framework;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ConnectionStatusComponent extends JLabel implements ConnectionStatusListener{
    private static final ImageIcon iconDisconnected;
    private static final ImageIcon iconConnecting;
    private static final ImageIcon iconConnected;

    static{
        iconDisconnected = new ImageIcon("edu/ntnu/cikmr/gui/graphics/network_disconnected.gif");
        iconConnecting = new ImageIcon("edu/ntnu/cikmr/gui/graphics/network_connecting.gif");
        iconConnected = new ImageIcon("edu/ntnu/cikmr/gui/graphics/network_connected.gif");
    }

    public ConnectionStatusComponent(){
        setIconTextGap(3);
        setBorder(BorderFactory.createEmptyBorder(0, 2, 0, 0));
        ConnectionStatus connectionStatus = Framework.network.getConnectionStatus();
        connectionStatusUpdated(connectionStatus);
        connectionStatus.addConnectionStatusListener(this);
    }

    public void connectionStatusUpdated(ConnectionStatus connectionStatus){
        if(connectionStatus.hasError()){
            iconConnecting.setImageObserver(null);
            setIcon(iconDisconnected);
            switch(connectionStatus.getErrorCode()){
                case ConnectionStatus.ERROR_UNKNOWN:
                    setText("Error: Unknown error");
                    break;
                case ConnectionStatus.ERROR_TIMED_OUT:
                    setText("Error: Timed out");
                    break;
                case ConnectionStatus.ERROR_CONNECTING_TO_NET_PEER_GROUP:
                    setText("Error connecting to net peer group");
                    break;
                case ConnectionStatus.ERROR_CONNECTING_TO_PEER_GROUP:
                    setText("Error connecting to peer group");
            }
        }else{
            switch(connectionStatus.getStatus()){
                case ConnectionStatus.STATUS_DISCONNECTED:
                    iconConnecting.setImageObserver(null);
                    setIcon(iconDisconnected);
                    setText("Disconnected");
                    break;
                case ConnectionStatus.STATUS_CONFIGURATING_NETWORK:
                    setIcon(iconConnecting);
                    iconConnecting.setImageObserver(this);
                    setText("Configurating network...");
                    break;
                case ConnectionStatus.STATUS_CONNECTING_TO_NET_PEER_GROUP:
                    setIcon(iconConnecting);
                    iconConnecting.setImageObserver(this);
                    setText("Connecting to net peer group...");
                    break;
                case ConnectionStatus.STATUS_CONNECTING_TO_PEER_GROUP:
                    setIcon(iconConnecting);
                    iconConnecting.setImageObserver(this);
                    setText("Connecting to peer group...");
                    break;
                case ConnectionStatus.STATUS_DISCONNECTING:
                    setIcon(iconConnecting);
                    iconConnecting.setImageObserver(this);
                    setText("Disconnecting from peer group...");
                    break;
                case ConnectionStatus.STATUS_CONNECTED:
                    iconConnecting.setImageObserver(null);
                    setIcon(iconConnected);
                    setText("Connected (" + connectionStatus.getPeerName() + ")");
            }
        }
    }

}
