package edu.ntnu.cikmr.gui;

import java.util.*;

import javax.swing.*;
import javax.swing.table.*;

import edu.ntnu.cikmr.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class LogComponent extends JTable{
    private LogDataModel dataModel;

    public LogComponent(){
        if(Framework.log instanceof LogComponentLog){
            ((LogComponentLog)Framework.log).setLogComponent(this);
        }else{
            LogComponentLog log = new LogComponentLog();
            Framework.log = log;
            log.setLogComponent(this);
        }
        dataModel = new LogDataModel();
        setModel(dataModel);
    }

    protected void logEntryAdded(ArrayList entries, boolean truncated){
        dataModel.fireEntryAdded(entries, truncated);
    }

    private class LogDataModel extends AbstractTableModel{
        private ArrayList entries;

        public LogDataModel(){
            entries = new ArrayList(0);
        }

        public int getColumnCount() { return 3; }
        public int getRowCount() { return entries.size(); }
        public Object getValueAt(int row, int col) {
            LogComponentLogEntry entry = (LogComponentLogEntry)entries.get(row);
            switch(col){
                case 0:
                    return entry.level;
                case 1:
                    return entry.source;
                case 2:
                    return entry.message;
            }
            return "";
        }
        public String getColumnName(int columnIndex){
            switch(columnIndex){
                case 0:
                    return "Level";
                case 1:
                    return "Source";
                case 2:
                    return "Message";
            }
            return "";
        }
        public void fireEntryAdded(ArrayList log, boolean truncated){
            entries = log;
            if(truncated) fireTableRowsUpdated(0, entries.size() - 1); else fireTableRowsInserted(0, 0);
        }
    };
}
