package edu.ntnu.cikmr.gui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import edu.ntnu.cikmr.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

public class Main extends JFrame{
    private ConnectionStatusComponent connectionStatusComponent;
    private JTabbedPane tabbedPane;
    private PeersComponent peerList;
    private LocationComponent location;
    private LogComponent logComponent;
    private ArbitrationComponent arbitrationComponent;
    private WorkflowComponent workflowComponent;
    private ResourceComponent resourceComponent;

    public Main(){
        super("Network application");
        setSize(800, 600);
        setLocation((int)(getToolkit().getScreenSize().getWidth() - getWidth()) / 2, (int)(getToolkit().getScreenSize().getHeight() - getHeight()) / 2);
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter(){
          public void windowClosing(WindowEvent e){
            closeWindow(e);
          }
        });
        setIconImage(new ImageIcon("edu/ntnu/cikmr/gui/graphics/antenna.gif").getImage());
        JPanel contentPane = (JPanel)getContentPane();
        contentPane.setLayout(new BorderLayout());

        tabbedPane = new JTabbedPane(JTabbedPane.TOP);
        contentPane.add(tabbedPane, BorderLayout.CENTER);

        logComponent = new LogComponent();
        JScrollPane logComponentScroll = new JScrollPane(logComponent);
        logComponentScroll.setBorder(BorderFactory.createEtchedBorder());
        tabbedPane.addTab("Log", new ImageIcon("edu/ntnu/cikmr/gui/graphics/log.gif"), logComponentScroll, "See the log.");

        peerList = new PeersComponent();
        JScrollPane peerListScroll = new JScrollPane(peerList);
        peerListScroll.setBorder(BorderFactory.createEtchedBorder());
        tabbedPane.addTab("Peers", new ImageIcon("edu/ntnu/cikmr/gui/graphics/peers.gif"), peerListScroll, "See all discovered peers.");

        location = new LocationComponent();
        JScrollPane locationScroll = new JScrollPane(location);
        locationScroll.setBorder(BorderFactory.createEtchedBorder());
        tabbedPane.addTab("Location", new ImageIcon("edu/ntnu/cikmr/gui/graphics/map.gif"), locationScroll, "See the location of peers.");

        arbitrationComponent = new ArbitrationComponent();
        arbitrationComponent.setBorder(BorderFactory.createEtchedBorder());
        tabbedPane.addTab("Arbitration",  new ImageIcon("edu/ntnu/cikmr/gui/graphics/arbitration.gif"), arbitrationComponent, "Arbitration CBR context");

        resourceComponent = new ResourceComponent();
        resourceComponent.setBorder(BorderFactory.createEtchedBorder());
        tabbedPane.addTab("Resources",  new ImageIcon("edu/ntnu/cikmr/gui/graphics/resources.gif"), resourceComponent, "Resoures");

        workflowComponent = new WorkflowComponent();
        workflowComponent.setBorder(BorderFactory.createEtchedBorder());
        tabbedPane.addTab("Workflows",  new ImageIcon("edu/ntnu/cikmr/gui/graphics/workflows.gif"), workflowComponent, "Workflows");

        connectionStatusComponent = new ConnectionStatusComponent();
        connectionStatusComponent.setPreferredSize(new Dimension(400, 20));
        connectionStatusComponent.setMinimumSize(new Dimension(20, 20));
        connectionStatusComponent.setMaximumSize(new Dimension(10000, 20));
        contentPane.add(connectionStatusComponent, BorderLayout.SOUTH);
    }

    private void closeWindow(WindowEvent e){
        Framework.shutdown();
    }

}
