package edu.ntnu.cikmr.gui;

import java.awt.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;

import edu.ntnu.cikmr.*;
import edu.ntnu.cikmr.services.*;
import edu.ntnu.cikmr.services.peers.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class PeersComponent extends JList{
    private PeersService peersService;

    public PeersComponent(){
        peersService = (PeersService)Framework.network.getServiceManager().get(PeersService.class);
        if(peersService == null){
            peersService = new PeersService();
            Framework.network.getServiceManager().add(peersService);
        }
        PeerListModel model = new PeerListModel();
        peersService.addServiceListener(model);
        peersService.addPeerListener(model);
        setModel(model);
        setCellRenderer(new PeerListCellRenderer());
    }

    private class PeerListModel extends AbstractListModel implements ServiceListener, PeerListener{
        private Peer[] peers;

        public PeerListModel(){
            peers = new Peer[0];
        }

        public void peerAdded(PeerEvent e){
            peers = peersService.getPeers();
            fireContentsChanged(this, 0, getSize());
        }

        public void peerRemoved(PeerEvent e){
            peers = peersService.getPeers();
            fireContentsChanged(this, 0, getSize());
        }

        public int getSize(){
            return peers.length;
        }

        public Object getElementAt(int index){
            return peers[index];
        }

        public void serviceStarted(ServiceEvent e){
            peers = peersService.getPeers();
            fireContentsChanged(this, 0, peers.length);
        }

        public void serviceStopped(ServiceEvent e){
            peers = new Peer[0];
            fireContentsChanged(this, 0, 0);
        }

    }

    private class PeerListCellRenderer extends JLabel implements ListCellRenderer{
        private ImageIcon iconPeer_1;
        private Border borderNone;
        private Border borderFocus;

        public PeerListCellRenderer(){
            iconPeer_1 = new ImageIcon("edu/ntnu/cikmr/gui/graphics/peer_1.gif");
            borderNone = BorderFactory.createEmptyBorder(1, 1, 1, 1);
            borderFocus = BorderFactory.createLineBorder(SystemColor.controlShadow, 1);
            setPreferredSize(new Dimension(50, 16));
            setOpaque(true);
            setVisible(true);
        }

        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus){
            if(isSelected){
                setBackground(list.getSelectionBackground());
                setForeground(list.getSelectionForeground());
            }else{
                setBackground(list.getBackground());
                setForeground(list.getForeground());
            }
            setBorder(cellHasFocus ? borderFocus : borderNone);
            if(value != null){
                Peer peer = (Peer)value;
                setIcon(iconPeer_1);
                setText(peer.getName());
            }else{
                setIcon(null);
                setText("<Unsupported peer>");
            }
            return this;
        }
    }

}
