


package edu.ntnu.cikmr.gui;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;

import edu.ntnu.cikmr.Framework;
import edu.ntnu.cikmr.services.resources.*;
import edu.ntnu.cikmr.services.temperature.*;
import java.awt.event.*;
import java.awt.*;

public class ResourceComponent extends JPanel implements ResourceListener{
    private JMenuBar menuBar;
    private JMenu menuAddResource;
    private JMenu menuAddTemperatureSensor;
    private JMenuItem[] menuAddTemperatureSensorItems;
    private JMenu menuAddTemperatureActuator;
    private JMenuItem[] menuAddTemperatureActuatorItems;
    private JPopupMenu menuResource;
    private JMenuItem menuViewResourceDescription;
    private JMenu menuRunMethod;
    private JMenuItem menuNoMethods;

    private JList resourceList;

    public ResourceComponent() {
        super(new BorderLayout());

        menuAddTemperatureActuatorItems = new JMenuItem[5];

        menuAddTemperatureActuatorItems[0] = new JMenuItem("White room");
        menuAddTemperatureActuatorItems[0].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureActuatorWhiteRoomResource());
            }
        });
        menuAddTemperatureActuatorItems[1] = new JMenuItem("Yellow room");
        menuAddTemperatureActuatorItems[1].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureActuatorYellowRoomResource());
            }
        });
        menuAddTemperatureActuatorItems[2] = new JMenuItem("Pink room");
        menuAddTemperatureActuatorItems[2].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureActuatorPinkRoomResource());
            }
        });
        menuAddTemperatureActuatorItems[3] = new JMenuItem("Blue room");
        menuAddTemperatureActuatorItems[3].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureActuatorBlueRoomResource());
            }
        });
        menuAddTemperatureActuatorItems[4] = new JMenuItem("Green room");
        menuAddTemperatureActuatorItems[4].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureActuatorGreenRoomResource());
            }
        });

        menuAddTemperatureActuator = new JMenu("Temperature actuator");
        menuAddTemperatureActuator.add(menuAddTemperatureActuatorItems[0]);
        menuAddTemperatureActuator.add(menuAddTemperatureActuatorItems[1]);
        menuAddTemperatureActuator.add(menuAddTemperatureActuatorItems[2]);
        menuAddTemperatureActuator.add(menuAddTemperatureActuatorItems[3]);
        menuAddTemperatureActuator.add(menuAddTemperatureActuatorItems[4]);

        menuAddTemperatureSensorItems = new JMenuItem[5];

        menuAddTemperatureSensorItems[0] = new JMenuItem("White room");
        menuAddTemperatureSensorItems[0].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureSensorWhiteRoomResource());
            }
        });
        menuAddTemperatureSensorItems[1] = new JMenuItem("Yellow room");
        menuAddTemperatureSensorItems[1].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureSensorYellowRoomResource());
            }
        });
        menuAddTemperatureSensorItems[2] = new JMenuItem("Pink room");
        menuAddTemperatureSensorItems[2].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureSensorPinkRoomResource());
            }
        });
        menuAddTemperatureSensorItems[3] = new JMenuItem("Blue room");
        menuAddTemperatureSensorItems[3].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureSensorBlueRoomResource());
            }
        });
        menuAddTemperatureSensorItems[4] = new JMenuItem("Green room");
        menuAddTemperatureSensorItems[4].addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                Framework.network.getServiceManager().add(new TemperatureSensorGreenRoomResource());
            }
        });

        menuAddTemperatureSensor = new JMenu("Temperature sensor");
        menuAddTemperatureSensor.add(menuAddTemperatureSensorItems[0]);
        menuAddTemperatureSensor.add(menuAddTemperatureSensorItems[1]);
        menuAddTemperatureSensor.add(menuAddTemperatureSensorItems[2]);
        menuAddTemperatureSensor.add(menuAddTemperatureSensorItems[3]);
        menuAddTemperatureSensor.add(menuAddTemperatureSensorItems[4]);

        menuAddResource = new JMenu("Add resource");
        menuAddResource.add(menuAddTemperatureSensor);
        menuAddResource.add(menuAddTemperatureActuator);

        menuBar = new JMenuBar();
        menuBar.add(menuAddResource);

        menuViewResourceDescription = new JMenuItem("View description");
        menuViewResourceDescription.addActionListener(new ActionListener() {
                                        public void actionPerformed(ActionEvent e) {
                                            viewDescription();
                                        }
                                    });

        menuNoMethods = new JMenuItem("No methods");
        menuNoMethods.setEnabled(false);

        menuRunMethod = new JMenu("Run method");

        menuResource = new JPopupMenu();
        menuResource.add(menuViewResourceDescription);
        menuResource.add(menuRunMethod);

        resourceList = new JList(Framework.resources.getAll());
        resourceList.setCellRenderer(new ResourceListCellRenderer());
        resourceList.addMouseListener(new MouseAdapter() {
                         public void mouseClicked(MouseEvent e) {
                             displayMenu(e);
                         }
                     });
        resourceList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        JScrollPane resourceListScroll = new JScrollPane(resourceList);

        Framework.resources.addResourceListener(this);

        add(menuBar, BorderLayout.NORTH);
        add(resourceListScroll, BorderLayout.CENTER);
    }

    private void viewDescription(){
        Object o = resourceList.getSelectedValue();
        if(o == null || !(o instanceof Resource)) return;
        Resource resource = (Resource)o;

        JTextArea descText = new JTextArea(ResourceDescription.toXML(resource.getResourceDescription()));
        JScrollPane descScroll = new JScrollPane(descText);
        descScroll.setPreferredSize(new Dimension(500, 200));
        JOptionPane.showMessageDialog(resourceList, descScroll, "Resource Description", JOptionPane.INFORMATION_MESSAGE);
    }

    private void runMethod(ActionEvent e){
        Object o = resourceList.getSelectedValue();
        if(o == null || !(o instanceof Resource)) return;
        Resource resource = (Resource)o;
        try {
            int index = Integer.parseInt(e.getActionCommand(), 10);
            ResourceMethod method = resource.getResourceDescription().getMethods()[index];

            String[] parameterTypes = method.getParameters();
            String[] parameters = new String[parameterTypes.length];
            for (int i = 0; i < parameterTypes.length; i++) {
                parameters[i] = JOptionPane.showInputDialog(resourceList, "Type in a " + parameterTypes[i] + " value:", "Parameter", JOptionPane.QUESTION_MESSAGE);
            }
            InvocationResult result = resource.invokeMethod(method, parameters);
            if(!result.getDataType().equalsIgnoreCase("void")) JOptionPane.showMessageDialog(this, result.getReturnValue(), "Method invocation result", JOptionPane.INFORMATION_MESSAGE);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    private void displayMenu(MouseEvent e){
        if(e.getButton() != e.BUTTON3) return;
        Object o = resourceList.getSelectedValue();
        if(o == null || !(o instanceof Resource)) return;
        Resource resource = (Resource)o;

        menuRunMethod.removeAll();
        ResourceMethod[] methods = resource.getResourceDescription().getMethods();
        if(methods.length == 0){
            menuRunMethod.add(menuNoMethods);
        }else{
            for (int i = 0; i < methods.length; i++) {
                ResourceMethod method = methods[i];
                String name = method.getMethodName() + "(";
                for (int j = 0; j < method.getParameters().length; j++) {
                    name += j == 0 ? "" : ", ";
                    name += method.getParameters()[j];
                }
                name += ") : " + method.getReturnType();
                JMenuItem menuItem = new JMenuItem(name);
                menuItem.setActionCommand("" + i);
                menuItem.addActionListener(new ActionListener() {
                             public void actionPerformed(ActionEvent e) {
                                 runMethod(e);
                             }
                         });
                menuRunMethod.add(menuItem);
            }
        }
        menuResource.show(e.getComponent(), e.getX(), e.getY());
    }

    private class ResourceListCellRenderer extends JLabel implements ListCellRenderer{
        public ResourceListCellRenderer(){
            setOpaque(true);
            setBorder(BorderFactory.createEmptyBorder(0, 1, 0, 1));
        }

        public Component getListCellRendererComponent(JList jList, Object object, int _int, boolean _boolean, boolean _boolean4){
            setBackground(_boolean ? jList.getSelectionBackground() : jList.getBackground());
            setForeground(_boolean ? jList.getSelectionForeground() : jList.getForeground());

            if(object instanceof Resource){
                Resource resource = (Resource)object;
                setText(resource.getResourceDescription().getDescription());
            }else{
                setText("<Unknown resource>");
            }
            return this;
        }

    }

    public void resourceFound(ResourceEvent e){
        resourceList.setListData(Framework.resources.getAll());
    }

    public void resourceLost(ResourceEvent e){
        resourceList.setListData(Framework.resources.getAll());
    }

}
