package edu.ntnu.cikmr.gui;

import javax.swing.*;
import edu.ntnu.cikmr.scheduling.SchedulerListener;
import edu.ntnu.cikmr.workflowenactment.WorkflowEvent;
import edu.ntnu.cikmr.Framework;
import java.awt.Component;

public class WorkflowComponent extends JTabbedPane implements SchedulerListener{
    private WorkflowDefinitions workflowDefinitions;
    private ImageIcon iconDefinitions;
    private ImageIcon iconWorkflow;

    public WorkflowComponent() {
        iconDefinitions = new ImageIcon("edu/ntnu/cikmr/gui/graphics/definitions.gif");
        iconWorkflow = new ImageIcon("edu/ntnu/cikmr/gui/graphics/workflow.gif");

        workflowDefinitions = new WorkflowDefinitions();
        this.addTab("Definitions", iconDefinitions, workflowDefinitions, "The workflow definitions.");
        Framework.scheduler.addSchedulerListener(this);
    }

    public void workflowAdded(WorkflowEvent e){
        this.addTab("", iconWorkflow, new WorkflowPanel(e.getWorkflow()), "An instanciated workflow.");
    }

    public void workflowRemoved(WorkflowEvent e){
        Component[] components = this.getComponents();
        for(int i = 0; i < components.length; i++){
            Component component = components[i];
            if(component instanceof WorkflowPanel){
                if(((WorkflowPanel)component).getWorkflow() == e.getWorkflow()) this.remove(component);
            }
        }
    }

}
