package edu.ntnu.cikmr.network;

import edu.ntnu.cikmr.*;
import edu.ntnu.cikmr.log.*;
import net.jxta.peergroup.*;
import edu.ntnu.cikmr.services.*;

public class Network implements ConnectionStatusListener{
    private static Network instance;
    private PeerGroupConnection peerGroupConnection;
    private ServiceManager serviceManager;

    private Network(){
        peerGroupConnection = new PeerGroupConnection();
        peerGroupConnection.getConnectionStatus().addConnectionStatusListener(this);
        serviceManager = new ServiceManager();
    }

    public static Network getInstance(){
        return instance == null ? (instance = new Network()) :  instance;
    }

    public ServiceManager getServiceManager() {
        return serviceManager;
    }

    public void connect(){
        peerGroupConnection.connect();
    }

    public void disconnect(){
        try{
            peerGroupConnection.disconnect();
        } catch(Exception ex){}
    }

    public ConnectionStatus getConnectionStatus(){
        return peerGroupConnection.getConnectionStatus();
    }

//------------------------------------------------------------------------------

    public PeerGroup getPeerGroup(){
        return peerGroupConnection.getPeerGroup();
    }

    public void connectionStatusUpdated(ConnectionStatus connectionStatus){
        if(connectionStatus.isConnected()){
            Framework.log.logMessage(this, Log.LEVEL_INFORMATIVE, "My peer ID is " + getPeerGroup().getPeerID());
            System.out.println(getPeerGroup().getPeerID().getUniqueValue().toString());
            serviceManager.startServices();
        }else if(connectionStatus.getStatus() == ConnectionStatus.STATUS_DISCONNECTING){
            serviceManager.stopServices();
        }
    }
}
