package edu.ntnu.cikmr.services;

import java.util.*;

import javax.swing.event.*;

public abstract class AbstractService implements Service {
    protected EventListenerList listenerList;

    public AbstractService() {
        listenerList = new EventListenerList();
    }

    public void addServiceListener(ServiceListener l){
        listenerList.add(ServiceListener.class, l);
    }

    public void removeServiceListner(ServiceListener l){
        listenerList.remove(ServiceListener.class, l);
    }

    protected void fireServiceStarted(Service service){
        ServiceEvent event = null;
        ServiceListener[] listeners = (ServiceListener[])listenerList.getListeners(ServiceListener.class);
        for(int i = listeners.length - 1; i >= 0; i--){
            if(event == null) event = new ServiceEvent(this, service);
            listeners[i].serviceStarted(event);
        }
    }

    protected void fireServiceStopped(Service service){
        ServiceEvent event = null;
        ServiceListener[] listeners = (ServiceListener[])listenerList.getListeners(ServiceListener.class);
        for(int i = listeners.length - 1; i >= 0; i--){
            if(event == null) event = new ServiceEvent(this, service);
            listeners[i].serviceStopped(event);
        }
    }

}
