package edu.ntnu.cikmr.services.context.items;

import dk.pervasive.jcaf.item.*;


public class Location extends AbstractContextItem{
    private String urn;
    private double latitude;
    private double longitude;
    private double elevation;

    public Location(){
        super();
    }

    public Location(String urn){
        super(urn);
        this.urn = urn;
    }

    /**
     * Generate a XML-document of this location object
     * <?xml version="1.0" encoding="UTF-16"?>
     * <!DOCTYPE Location>
     * <location>
     *   <latitude>double</latitude>     (y-coordinate)
     *   <longitude>double</longitude>   (x-coordiate)
     *   <elevation>double</elevation>   (z-coordiante)
     * </location>
     *
     * @return a String of the XML-document
     */
    public String toXML() {
        return "<location id=\"" + getId() + "\" urn=\"" + urn + "\" latitude=\"" + latitude + "\" longitude=\"" + longitude + "\" elevation=\"" + elevation + "\">null</location>";
    }

    public double getElevation() {
        return elevation;
    }

    public double getLatitude() {
        return latitude;
    }

    public double getLongitude() {
        return longitude;
    }

    public String getUrn() {
        return urn;
    }

    public void setLongitude(double longitude) {
        this.longitude = longitude;
    }

    public void setLatitude(double latitude) {
        this.latitude = latitude;
    }

    public void setElevation(double elevation) {
        this.elevation = elevation;
    }

    public void setUrn(String urn) {
        this.urn = urn;
    }

}
