package edu.ntnu.cikmr.services.location;

import java.io.*;

import edu.ntnu.cikmr.*;
import edu.ntnu.cikmr.services.*;
import edu.ntnu.cikmr.services.resources.*;
import net.jxta.peergroup.*;

public class LocationSensorResource extends AbstractResourceService{
    private boolean isStarted;
    private ResourceDescription resourceDescription;
    private int x;
    private int y;
    private int z;
    private String location;;

    /**
     * init
     *
     * @param manager ServiceManager
     * @todo Implement this edu.ntnu.cikmr.services.Service method
     */
    public void init(ServiceManager manager) {
        resourceDescription = new ResourceDescription();
        resourceDescription.setType(Framework.ontologies.getInstanceByLocalName("Location_sensor"));
        resourceDescription.setDescription("Location sensor for this device.");
        resourceDescription.setLocation(null);

        ResourceMethod getLocationXMethod = new ResourceMethod();
        getLocationXMethod.setMethodName("getLocationX");
        getLocationXMethod.setReturnType("int");
        resourceDescription.addMethod(getLocationXMethod);

        ResourceMethod getLocationYMethod = new ResourceMethod();
        getLocationYMethod.setMethodName("getLocationY");
        getLocationYMethod.setReturnType("int");
        resourceDescription.addMethod(getLocationYMethod);

        ResourceMethod getLocationZMethod = new ResourceMethod();
        getLocationZMethod.setMethodName("getLocationZ");
        getLocationZMethod.setReturnType("int");
        resourceDescription.addMethod(getLocationZMethod);

        ResourceMethod getLocationMethod = new ResourceMethod();
        getLocationMethod.setMethodName("getLocation");
        getLocationMethod.setReturnType("String");
        resourceDescription.addMethod(getLocationMethod);
    }

    public int getLocationX(){
        return x;
    }

    public int getLocationY(){
        return y;
    }

    public int getLocationZ(){
        return z;
    }

    public String getLocation(){
        return location;
    }

    public void setLocationX(int x){
        this.x = x;
    }

    public void setLocationY(int y){
        this.y = y;
    }

    public void setLocationZ(int z){
        this.z = z;
    }

    public void setLocation(String location){
        this.location = location;
    }

    /**
     * isStarted
     *
     * @return boolean
     * @todo Implement this edu.ntnu.cikmr.services.Service method
     */
    public boolean isStarted() {
        return isStarted;
    }

    /**
     * start
     *
     * @param peerGroup PeerGroup
     * @throws IOException
     * @todo Implement this edu.ntnu.cikmr.services.Service method
     */
    public void start(PeerGroup peerGroup) throws IOException {
        isStarted = true;
        try {
            startResource(peerGroup);
        } catch (InstantiationException ex) {
            isStarted = false;
            throw new IOException("Unable to start resource.");
        }
        fireServiceStarted(this);
    }

    /**
     * stop
     *
     * @throws IOException
     * @todo Implement this edu.ntnu.cikmr.services.Service method
     */
    public void stop() throws IOException {
        isStarted = false;
        stopResource();
        fireServiceStopped(this);
    }

    public ResourceDescription getResourceDescription() {
        return resourceDescription;
    }

}
