package edu.ntnu.cikmr.services.temperature;

import java.io.*;

import net.jxta.peergroup.*;
import edu.ntnu.cikmr.services.*;
import edu.ntnu.cikmr.services.resources.*;
import edu.ntnu.cikmr.*;
import edu.ntnu.cikmr.services.resources.sensors.*;

public class TemperatureSensorYellowRoomResource extends AbstractResourceService implements SimpleNumericSensor{
    private boolean isStarted;
    private ResourceDescription resourceDescription;

    /**
     * init
     *
     * @param manager ServiceManager
     * @todo Implement this edu.ntnu.cikmr.services.Service method
     */
    public void init(ServiceManager manager) {
        resourceDescription = new ResourceDescription();
        resourceDescription.setType(Framework.ontologies.getInstanceByLocalName("Temperature_sensor"));
        resourceDescription.setDescription("Temperature sensor in the yellow room.");
        resourceDescription.setLocation(Framework.ontologies.getInstanceByLocalName("Yellow_room"));

        ResourceMethod getTemperatureMethod = new ResourceMethod();
        getTemperatureMethod.setMethodName("getTemperature");
        getTemperatureMethod.setReturnType("double");
        resourceDescription.addMethod(getTemperatureMethod);

        getTemperatureMethod = new ResourceMethod();
        getTemperatureMethod.setMethodName("getValue");
        getTemperatureMethod.setReturnType("double");
        resourceDescription.addMethod(getTemperatureMethod);
    }

    public double getTemperature(){
        return Temperature.temperatureYellowRoom;
    }

    /**
     * isStarted
     *
     * @return boolean
     * @todo Implement this edu.ntnu.cikmr.services.Service method
     */
    public boolean isStarted() {
        return isStarted;
    }

    /**
     * start
     *
     * @param peerGroup PeerGroup
     * @throws IOException
     * @todo Implement this edu.ntnu.cikmr.services.Service method
     */
    public void start(PeerGroup peerGroup) throws IOException {
        isStarted = true;
        try {
            startResource(peerGroup);
        } catch (InstantiationException ex) {
            isStarted = false;
            throw new IOException("Unable to start resource.");
        }
        fireServiceStarted(this);
    }

    /**
     * stop
     *
     * @throws IOException
     * @todo Implement this edu.ntnu.cikmr.services.Service method
     */
    public void stop() throws IOException {
        isStarted = false;
        stopResource();
        fireServiceStopped(this);
    }

    public ResourceDescription getResourceDescription() {
        return resourceDescription;
    }

    public double getValue() {
        return getTemperature();
    }

}
