package edu.ntnu.cikmr.workflowenactment;

import edu.ntnu.cikmr.workflow.ExecutableActivity;
import edu.ntnu.cikmr.workflow.Statement;

public class SimpleWorkflowLog extends WorkflowLog{

    public void logMessage(Object source, int level, String message){
        String activity = null;
        String statement = null;
        if(source instanceof ExecutableActivity){
            ExecutableActivity ea = (ExecutableActivity)source;
            activity = ea.getId() + (ea.getType() == null ? "" : " (" + ea.getType().getLocalName() + ")");
        }else if(source instanceof Statement){
            Statement s = (Statement)source;
            ExecutableActivity ea = s.getParent();
            activity = ea.getId() + (ea.getType() == null ? "" : " (" + ea.getType().getLocalName() + ")");
            statement = s.getClass().getSimpleName();
        }else{
            activity = "Unknown (" + source.getClass().getSimpleName() + ")";
        }
        addEntry(new WorkflowLogEntry(activity, statement, level, message));
    }

}
