package edu.ntnu.cikmr.workflowenactment;

import edu.ntnu.cikmr.workflow.Goal;
import javax.swing.event.EventListenerList;
import edu.ntnu.cikmr.log.Log;
import edu.ntnu.cikmr.log.PrintStreamLog;

public class WorkflowContext{
    private Goal goal;
    private boolean halt;
    private EventListenerList listenerList;
    private Log log;

    public WorkflowContext(){
        listenerList = new EventListenerList();
        log = new PrintStreamLog();
    }

    public Log getLog(){
        return log;
    }

    public void setLog(Log log){
        this.log = log;
    }

    public Goal getGoal(){
        return goal;
    }

    public boolean isHalted(){
        return halt;
    }

    public void setHalted(boolean halt){
        this.halt = halt;
    }

    public void setGoal(Goal goal){
        goal.setWorkflowContext(this);
        this.goal = goal;
    }

    public boolean execute(){
        return goal.execute();
    }

    public boolean invokeControlCommand(String command){
        WorkflowControlEvent event = new WorkflowControlEvent(this, command);
        WorkflowControlListener[] listeners = listenerList.getListeners(WorkflowControlListener.class);
        for(int i = listeners.length - 1; i >= 0; i--){
            listeners[i].controlCommand(event);
            if(event.isCancelled()) return false;
        }
        return true;
    }

    public void addWorkflowControlListener(WorkflowControlListener l){
        listenerList.add(WorkflowControlListener.class, l);
    }

    public void removeWorkflowControlListener(WorkflowControlListener l){
        listenerList.remove(WorkflowControlListener.class, l);
    }

}
